"
    Copyright (c) 2016-now, Jan Vrany <jan . vrany [at] fit . cvut . cz>
    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, 
    are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, 
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice, 
       this list of conditions and the following disclaimer in the documentation 
       and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS IS' AND 
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
    ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"
"{ Package: 'jv:dragonfly/udis86sx' }"

"{ NameSpace: Smalltalk }"

LibraryDefinition subclass:#jv_dragonfly_udis86sx
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!jv_dragonfly_udis86sx class methodsFor:'documentation'!

copyright
"
    Copyright (c) 2016-now, Jan Vrany <jan . vrany [at] fit . cvut . cz>
    All rights reserved.

    Redistribution and use in source and binary forms, with or without modification, 
    are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, 
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice, 
       this list of conditions and the following disclaimer in the documentation 
       and/or other materials provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 'AS IS' AND 
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
    WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
    DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR 
    ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
    LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
    ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
    SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

"
! !

!jv_dragonfly_udis86sx class methodsFor:'description'!

additionalLinkLibraries_bc_dot_mak
    ^ 'udis86\libudis86\.libs\libudis86.a'

    "Created: / 14-06-2016 / 23:07:05 / jv"
!

additionalLinkLibraries_make_dot_proto
    ^ 'udis86/libudis86/.libs/libudis86.a'

    "Created: / 09-12-2015 / 08:08:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-12-2015 / 09:18:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalRules_bc_dot_mak
^ '
udis86\libudis86\.libs\libudis86.a: udis86\Makefile
        pushd udis86 & set "PATH=C:\MSYS64\usr\bin;C:\MINGW\MSYS\1.0\bin;C:\MSYS\1.0\bin;%%PATH%%" & make

udis86\Makefile: udis86\configure
        pushd udis86 & set "PATH=C:\MSYS64\usr\bin;C:\MINGW\MSYS\1.0\bin;C:\MSYS\1.0\bin;%%PATH%%" & bash configure


'

    "Created: / 14-06-2016 / 23:10:36 / jv"
!

additionalRules_make_dot_proto
^ '
udis86/libudis86/.libs/libudis86.a: udis86/Makefile
	$(MAKE) -C udis86

udis86/Makefile: udis86/configure
	cd udis86 && CFLAGS="$(CCCONFOPT) -fPIC" ./configure

'

    "Created: / 09-12-2015 / 09:18:19 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_bc_dot_mak
    ^ 'udis86\libudis86\.libs\libudis86.a'

    "Created: / 14-06-2016 / 23:07:28 / jv"
!

additionalTargets_make_dot_proto
    ^ 'udis86/libudis86/.libs/libudis86.a'

    "Created: / 09-12-2015 / 08:08:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 09-12-2015 / 09:18:30 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

excludedFromPreRequisites
    "list packages which are to be explicitely excluded from the automatic constructed
     prerequisites list. If empty, everything that is found along the inheritance of any of
     my classes is considered to be a prerequisite package."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
        #'stx:libbasic'    "LibraryDefinition - superclass of jv_dragonfly_udis86sx"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for compiling or loading,
     however, a class from it may be referenced during execution and having it
     unloaded then may lead to a runtime doesNotUnderstand error, unless the caller
     includes explicit checks for the package being present.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites."

    ^ #(
    )
! !

!jv_dragonfly_udis86sx class methodsFor:'description - compilation'!

localIncludes
    "allow for the specification of additional include directories"

    ^ '-Iudis86'

    "Created: / 10-12-2015 / 16:46:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_dragonfly_udis86sx class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        UDIS86
        UDIS86Instruction
        #'jv_dragonfly_udis86sx'
    )
!

extensionMethodNames
    "list class/selector pairs of extensions.
     A correponding method with real names must be present in my concrete subclasses"

    ^ #(
    )
! !

!jv_dragonfly_udis86sx class methodsFor:'description - project information'!

companyName
    "Returns a company string which will appear in <lib>.rc.
     Under win32, this is placed into the dlls file-info"

    ^ 'Jan Vrany'

    "Modified: / 09-12-2015 / 07:59:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

description
    "Returns a description string which will appear in nt.def / bc.def"

    ^ 'X86 Disassembler'

    "Modified: / 09-12-2015 / 07:59:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

legalCopyright
    "Returns a copyright string which will appear in <lib>.rc.
     Under win32, this is placed into the dlls file-info"

    ^ 'Copyright (C) 2015-now Jan Vrany <jan.vrany@fit.cvut.cz>'

    "Modified: / 09-12-2015 / 08:00:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

productName
    "Returns a product name which will appear in <lib>.rc.
     Under win32, this is placed into the dlls file-info.
     This method is usually redefined in a concrete application definition"

    ^ 'udis86sx'

    "Modified: / 09-12-2015 / 08:00:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_dragonfly_udis86sx class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

